#!/usr/bin/python
# -*- coding: utf-8 -*-

__version__ = '$Id$'
__author__ = 'Raphaël Bollen'
__license__ = 'GPL V2.0'
__url__ = 'none yet!'
__doc__ = \
"""Expect script to set audio irq to realtime.

Copyright %s (2007)
Version: %s
License: %s
Homepage: %s

""" % (__author__,__version__,__license__,__url__)


import pexpect
import re
import time


reg_irq = re.compile("(\d+):(.*)HDA Intel(.*)")
reg_pci = re.compile("([0-9a-fA-F]{2}:[0-9a-fA-F]{2})\.\d{1} Audio device")

# hi res timers
cmd = "sudo echo 8192 > /proc/sys/dev/rtc/max-user-freq"
print cmd
hires = pexpect.spawn(cmd)
try:
    hires.expect("[pP]assword", timeout=2)
    hires.sendline('evh5150')
except pexpect.EOF:
    print "EOF"
except pexpect.TIMEOUT:
    print "TIMEOUT"
print "Done!"

# PCI latency
lspci = pexpect.run('lspci')
print lspci

m = reg_pci.search(lspci)
if m:
    cmd = "sudo setpci -v -d *:* latency_timer=b0"
    print cmd
    child = pexpect.spawn(cmd)
    try:
        child.expect("[pP]assword", timeout=2)
        child.sendline('evh5150')
    except pexpect.EOF:
        print "EOF"
    except pexpect.TIMEOUT:
        print "TIMEOUT"

    cmd = "sudo setpci -v -s %s LATENCY_TIMER=ff" % m.group(1)
    print cmd
    child = pexpect.spawn(cmd)
    try:
        child.expect("[pP]assword", timeout=2)
        child.sendline('evh5150')
    except pexpect.EOF:
        print "EOF"
    except pexpect.TIMEOUT:
        print "TIMEOUT"
    print pexpect.run("setpci -v -s %s LATENCY_TIMER" % m.group(1))
    print "Done!"
    
# IRQ
irqs = pexpect.run('cat /proc/interrupts')
print irqs
m = reg_irq.search(irqs)
if m:
    pid = pexpect.run('pidof "IRQ-%s"' % m.group(1))
    print "found pid: %s" % pid
    cmd = 'sudo chrt -f -p 99 %s' % pid
    print cmd
    child = pexpect.spawn(cmd)
    try:
        child.expect("[pP]assword", timeout=2)
        child.sendline('evh5150')
    except pexpect.EOF:
        print "EOF"
    except pexpect.TIMEOUT:
        print "TIMEOUT"
    print "Done!"

